package PC20060626;

import ProSW.*;

public class Main {

	public static void main(String args[]) throws EccezionePrecondizioni, EccezioneMolteplicita {
		
		TipologiaAlimento pastaRiso = new TipologiaAlimento("Pasta&Riso");
		TipologiaAlimento funghi = new TipologiaAlimento("Funghi");
		TipologiaAlimento carne = new TipologiaAlimento("Carne");		
		TipologiaAlimento verdura = new TipologiaAlimento("Verdura");				
		TipologiaAlimento formaggi = new TipologiaAlimento("Formaggi");				
		TipologiaAlimento condimenti = new TipologiaAlimento("Condimenti");

		TipologiaAlimento pesce = new TipologiaAlimento("Pesce&Frutti di mare");
		
		Alimento fettuccine = new Alimento("Fettuccine", Alimento.GRAMMI, 5000, 2, pastaRiso);
		Alimento porcini = new Alimento("Funghi porcini", Alimento.GRAMMI, 500, 1, funghi);
		Alimento parmigiano = new Alimento("Parmigiano", Alimento.GRAMMI, 500, 3, formaggi);		
		
		Alimento olio = new Alimento("Olio", Alimento.LITRI, 2, 2, condimenti);		
		Alimento aglio = new Alimento("Aglio", Alimento.UNITA, 3, 1, condimenti);
		Alimento sale = new Alimento("Sale", Alimento.GRAMMI, 1000, 0, condimenti);
		Alimento succolimone = new Alimento("Succo di limone", Alimento.LITRI, 0.2, 0, condimenti);		
		Alimento pangrattato = new Alimento("Pan grattato", Alimento.GRAMMI, 500, 2, condimenti);		
		
		Alimento entrecote = new Alimento("Entrecote di vitello", Alimento.GRAMMI, 500, 3, carne);		
		Alimento insalata = new Alimento("Insalata", Alimento.GRAMMI, 500, 1, verdura);				

		Alimento orata = new Alimento("Orata", Alimento.GRAMMI, 500, 2, pesce);
		Alimento prezzemolo = new Alimento("Prezzemolo", Alimento.GRAMMI, 500, 0, condimenti);		


		Primo fettPorcini = new Primo("Fettuccine ai funghi porcini", 15);
		AssociazioneIngrediente.inserisciLink(fettPorcini, fettuccine, 100);
		AssociazioneIngrediente.inserisciLink(fettPorcini, porcini, 100);
		AssociazioneIngrediente.inserisciLink(fettPorcini, olio, 0.05);
		AssociazioneIngrediente.inserisciLink(fettPorcini, aglio, 1);
		AssociazioneIngrediente.inserisciLink(fettPorcini, prezzemolo, 10);		
		AssociazioneIngrediente.inserisciLink(fettPorcini, parmigiano, 10);
		fettPorcini.inserisciLinkIngredienteCar(fettuccine);
		fettPorcini.inserisciLinkIngredienteCar(porcini);


		Secondo entrecoteAllaGriglia = new Secondo("Entrecote di vitello alla griglia", 20);
		AssociazioneIngrediente.inserisciLink(entrecoteAllaGriglia, entrecote, 200);
		AssociazioneIngrediente.inserisciLink(entrecoteAllaGriglia, olio, 0.01);
		AssociazioneIngrediente.inserisciLink(entrecoteAllaGriglia, succolimone, 0.02);			
		entrecoteAllaGriglia.inserisciLinkIngredienteCar(entrecote);

		Contorno insalataVerde = new Contorno("Insalata verde", 2);
		AssociazioneIngrediente.inserisciLink(insalataVerde, insalata, 100);
		AssociazioneIngrediente.inserisciLink(insalataVerde, olio, 0.05);		
		AssociazioneIngrediente.inserisciLink(insalataVerde, succolimone, 0.02);		
		insalataVerde.inserisciLinkIngredienteCar(insalata);


		Secondo orataAlForno = new Secondo("Orata", 30);
		AssociazioneIngrediente.inserisciLink(orataAlForno, orata, 100);
		AssociazioneIngrediente.inserisciLink(orataAlForno, olio, 0.05);		
		AssociazioneIngrediente.inserisciLink(orataAlForno, succolimone, 0.02);
		AssociazioneIngrediente.inserisciLink(orataAlForno, pangrattato, 20);
		orataAlForno.inserisciLinkIngredienteCar(orata);


		/* Terminare per esercizio:
		   - Implementare le operazioni di classe e use-case
		   - Implementare la struttura dati Menu
		   - Invocare le operazioni per insegnare incompatibilita' ed 
		     ottenere dei menu suggeriti
		*/


	} // end main

} //:~
