package PC20060626;
import ProSW.*;

public final class AssociazioneIngrediente {
   private AssociazioneIngrediente() {}
   
   public static void inserisciLink(Piatto x, Alimento y, double q)
       throws EccezionePrecondizioni {

         AssociazioneIngrediente pass = new AssociazioneIngrediente();
         TipoLinkIngrediente l = new TipoLinkIngrediente(x, y, q);

	 x.inserisciLinkIngrediente(pass, l); 
 	 y.inserisciLinkIngrediente(pass, l);
   }   
   public static void eliminaLink(TipoLinkIngrediente l) throws EccezionePrecondizioni, EccezioneMolteplicita {
          AssociazioneIngrediente pass = new AssociazioneIngrediente();

		// Controllo vincolo "subset":  <l.getPiatto(), l.getAlimento()> NON deve essere in l.getPiatto().ingredienteCar
		if (l.getPiatto().getLinkIngredienteCar().contains( l.getAlimento() ) )
			throw new EccezionePrecondizioni("Vincolo subset non soddisfatto");

          l.getPiatto().eliminaLinkIngrediente(pass, l);
          l.getAlimento().eliminaLinkIngrediente(pass, l);
   }
} //:~
