package PC20060626;
import ProSW.*;

public class TipoLinkIngrediente {
  private final Piatto piatto;
  private final Alimento alimento;
  private double qta;

  TipoLinkIngrediente(Piatto x, Alimento y, double q) throws EccezionePrecondizioni {
	  
	if (x == null) throw new EccezionePrecondizioni("piatto non puo' essere null");
	piatto = x;
	
	if (y == null) throw new EccezionePrecondizioni("alimento non puo' essere null");	
	alimento = y;
	
	setQuantita(q);
  }
  
  public Piatto getPiatto() { return piatto; }
  public Alimento getAlimento() { return alimento; }
  public double getQuantita() { return qta; }
  
  public void setQuantita(double q) throws EccezionePrecondizioni {
  	if (q <= 0) throw new EccezionePrecondizioni("...");
  	qta = q;
  }
  
  
  public boolean equals(Object o) {
    if (o != null && getClass().equals(o.getClass())) {
      TipoLinkIngrediente t = (TipoLinkIngrediente)o;
      return piatto == t.piatto && alimento == t.alimento;
    }
    else return false;
  }
  public int hashCode() { return piatto.hashCode()+alimento.hashCode(); }
} //:~
